package ru.dbotthepony.mc.otm.shapes;

public record Rectangle(Point a, Point b, Point c, Point d) {
	public Rectangle rotate(double rad) {
		return new Rectangle(a.rotate(rad), b.rotate(rad), c.rotate(rad), d.rotate(rad));
	}

	public Rectangle translate(double x, double y) {
		return new Rectangle(a.translate(x, y), b.translate(x, y), c.translate(x, y), d.translate(x, y));
	}

	public Point min() {
		double x = a.x();
		double y = a.y();

		x = Math.min(x, b.x());
		y = Math.min(y, b.y());
		x = Math.min(x, c.x());
		y = Math.min(y, c.y());
		x = Math.min(x, d.x());
		y = Math.min(y, d.y());

		return new Point(x, y);
	}

	public Point max() {
		double x = a.x();
		double y = a.y();

		x = Math.max(x, b.x());
		y = Math.max(y, b.y());
		x = Math.max(x, c.x());
		y = Math.max(y, c.y());
		x = Math.max(x, d.x());
		y = Math.max(y, d.y());

		return new Point(x, y);
	}
}
